//+------------------------------------------------------------------+
//|                                       Bogie RSI-ATR Trend v3.mq4 |
//|                                                Bogie Enterprises |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Bogie Enterprises"


//       ====== input parameters ======

extern double     Lots              = 0.1;
extern bool       UseCloseSignal    = true; // if true, TakeProfit & StopLoss input values are not used
extern double     TakeProfit        = 50; 
extern double     StopLoss          = 100;
extern double     TrailingStop      = 0; // use 0 for no trailing stop


int               MagicNumber;
string            Name_Expert       = "Bogie RSI-ATR Trend v3.mq4";
double            StopLossLevel     = 0;
double            myRSI1            = 0;
double            myRSI2            = 0;
double            myRSI3            = 0;
double            myATR1            = 0;
double            myATR2            = 0;
double            myClose1          = 0;


//       ======= Program Start =======

int start()
  {
   if(Bars<100)
   {
      Print("bars less than 100");
      return(0);  
   }
   
//       ======= Order Trigger Calculation Routines =====   
   
   int Buy1=0, Buy2 =0, Sell1=0, Sell2=0; 
   myRSI1 =iRSI(NULL,0,21,PRICE_CLOSE,0);
   myRSI2 =iRSI(NULL,0,21,PRICE_CLOSE,1);
   myATR1 =iATR(NULL,0,21,0);
   myATR2 =iATR(NULL,0,21,1);
   myClose1 =iClose(NULL,0,1);
   

   
//          ====== 1st Buy Trigger ======   
   if( (myRSI2 < 50 && myRSI1 > 50) && Ask > myClose1 + (myATR2 * 0.2) && MyOrdersTotal()==0 ) Buy1=1; else Buy1=0;
   
//          ====== 2nd Buy Trigger ======   
   if( (myRSI2 < 60 && myRSI1 > 60) && MyOrdersTotal()==1) Buy2=1; else Buy2=0;

//          ====== 1st Sell Trigger ======      
   if( (myRSI2 > 50 && myRSI1 < 50) && Bid < myClose1 - (myATR2 * 0.2) && MyOrdersTotal()==0 ) Sell1=1; else Sell1=0;
   
//          ====== 2nd Sell Trigger ======   
   if( (myRSI2 > 40 && myRSI1 < 40) && MyOrdersTotal()==1) Sell2=1; else Sell2=0;
    
   
   if (Buy1==1) Comment("\n"," ====  BUY1  ====","\nmyRSI = ",myRSI1,"  myATR1 = ",myATR1,"  myATR2 = ",myATR2);
   if (Buy2==1) Comment("\n"," ====  BUY2  ====","\nmyRSI = ",myRSI1,"  myATR1 = ",myATR1,"  myATR2 = ",myATR2); 
   if (Sell1==1) Comment("\n"," ====  SELL1  ====","\nmyRSI = ",myRSI1,"  myATR1 = ",myATR1,"  myATR2 = ",myATR2); 
   if (Sell2==1) Comment("\n"," ====  SELL2  ====","\nmyRSI = ",myRSI1,"  myATR1 = ",myATR1,"  myATR2 = ",myATR2);
   if(Buy1==0 && Buy2==0 && Sell1==0 && Sell2==0) Comment("\nmyRSI = ",myRSI1,"  myATR1 = ",myATR1,"  myATR2 = ",myATR2);
   
   bool CLOSEBuyOrder1=false;
   bool CLOSEBuyOrder2=false;
   bool CLOSESellOrder1=false;
   bool CLOSESellOrder2=false;
   if( myRSI2 > 70 && myRSI1 < 70) CLOSEBuyOrder1=true;
   if( myRSI2 > 50 && myRSI1 < 50) CLOSEBuyOrder2=true;
   if( myRSI2 < 30 && myRSI1 > 30) CLOSESellOrder1=true;
   if( myRSI2 < 50 && myRSI1 > 50) CLOSESellOrder2=true;
   
   
   
   
   //          ====== Order Entry Routine =====  

   int cnt, ticket, total;
 
    if(MyOrdersTotal()<=1 ) 
      {
      if(Buy1==1 || Buy2==1) 
         {
         if (UseCloseSignal==false) StopLossLevel = Ask - (StopLoss * Point); else StopLossLevel = Ask-(myATR2*0.3);
         if (UseCloseSignal==true) TakeProfit= 0.0; else TakeProfit = Ask+TakeProfit*Point;
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,StopLossLevel,TakeProfit,"BUYSignal",12345,0,GreenYellow);
         if(ticket>0)
            {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
            }
            else Print("Error opening BUY order : ",GetLastError()); 
            return(0);
         }
      
      if(Sell1==1 || Sell2==1)
         {
         if (UseCloseSignal==false) StopLossLevel = Bid + (StopLoss * Point); else StopLossLevel = Bid+(myATR2*0.3);
         if (UseCloseSignal==true) TakeProfit= 0.0; else TakeProfit = Bid-TakeProfit*Point;
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,StopLossLevel,TakeProfit,"SELLSignal",12345,0,Red);
         if(ticket>0)
            {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
            }
            else Print("Error opening SELL order : ",GetLastError()); 
            return(0);
         }
      }
     
//             ======= Close Order Routines ======
  
   total = OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
      {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if((OrderType() <= OP_SELL) && (OrderSymbol() == Symbol()) && (OrderMagicNumber() == 12345))
         {
         if(OrderType() == OP_BUY)
            {
            if(TrailingStop > 0)
               {
               if((Bid-OrderOpenPrice()) > (Point*TrailingStop))
                  {
                  if((OrderStopLoss()) < (Bid-Point*TrailingStop))
                     {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*5,OrderTakeProfit(),0,GreenYellow);
                     return(0);
                     }
                  } 
               }
               if((UseCloseSignal == true) && (CLOSEBuyOrder1 == true || CLOSEBuyOrder2 == true) )
                  {
                  OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); 
                  return(0); 
                  }                 
             }

            if(OrderType() == OP_SELL)
               {
               if(TrailingStop > 0)
                  {
                  if(OrderOpenPrice()-Ask>Point*TrailingStop)
                     {
                     if(OrderStopLoss()>Ask+Point*TrailingStop)
                        {
                        OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*5,OrderTakeProfit(),0,Red);
                        return(0);              
                        }
                     }     
                  }
                  if((UseCloseSignal == true) && (CLOSESellOrder1 == true || CLOSESellOrder2 == true) )
                  {
                  OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); 
                  return(0); 
                  }
                }
             }
          }

   return(0);
  }
  
//          ====== Sub-Routiones ======

int MyOrdersTotal() { // included by Renato
   int Mytotal=0; 
   for (int i=0; i<OrdersTotal(); i++) { 
     if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
       if((OrderSymbol()==Symbol())&& (OrderMagicNumber()==12345)) 
          Mytotal++; 
   }  
   return(Mytotal); 
} 


//+-------------------- The End -----------------------------------+